import type { AreaEncodeChannels, SemanticTooltipOption, WithDefaultEncode, PlotAreaEncoderSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, CrosshairSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class Area extends SemanticMark<PlotAreaEncoderSpec, AreaEncodeChannels> {
    static readonly type = PlotMakType.area;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<PlotAreaEncoderSpec, AreaEncodeChannels>, AreaEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: AreaEncodeChannels, option: ValueOf<WithDefaultEncode<PlotAreaEncoderSpec, AreaEncodeChannels>, AreaEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotAreaEncoderSpec, AreaEncodeChannels>): GenerateBaseEncodeSpec<PlotAreaEncoderSpec>;
}
