"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.Line = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums");

class Line extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.line, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.line;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    setDefaultCrosshair() {
        return {
            x: {
                crosshairShape: "line"
            }
        };
    }
    setDefaultTooltip() {
        var _a, _b;
        return {
            disableGraphicTooltip: !0,
            title: null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.x,
            content: [ {
                value: null === (_b = this.spec.encode) || void 0 === _b ? void 0 : _b.y
            } ]
        };
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            y: markEncoder.y,
            x: markEncoder.x
        };
        return markEncoder.color || markEncoder.group ? res.stroke = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.stroke = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.stroke) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

exports.Line = Line, Line.type = enums_1.PlotMakType.line;
//# sourceMappingURL=line.js.map