import { SemanticMark } from "./semantic-mark";

import { GrammarMarkType } from "@visactor/vgrammar-core";

import { PlotMakType } from "./enums";

export class SymbolSemanticMark extends SemanticMark {
    constructor(id) {
        super(PlotMakType.symbol, id);
    }
    setMarkType() {
        return GrammarMarkType.symbol;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    setDefaultCrosshair() {
        return {
            x: {
                crosshairShape: "line"
            },
            y: {
                crosshairShape: "line"
            }
        };
    }
    setDefaultTooltip() {
        var _a, _b, _c;
        return {
            disableDimensionTooltip: !0,
            title: null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.group,
            content: [ {
                value: null === (_b = this.spec.encode) || void 0 === _b ? void 0 : _b.x
            }, {
                value: null === (_c = this.spec.encode) || void 0 === _c ? void 0 : _c.y
            } ]
        };
    }
    parseScaleByEncode(channel, option) {
        return "size" === channel ? {
            type: "linear",
            id: this.getScaleId("size"),
            domain: {
                data: this.getDataIdOfFiltered(),
                field: option
            },
            range: [ SymbolSemanticMark.defaultSpec.size, SymbolSemanticMark.defaultSpec.size ]
        } : "shape" === channel ? {
            type: "ordinal",
            id: this.getScaleId("shape"),
            domain: {
                data: this.getDataIdOfMain(),
                field: option
            }
        } : this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            x: markEncoder.x,
            y: markEncoder.y
        };
        return markEncoder.shape && (res.symbolType = markEncoder.shape), markEncoder.size && (res.size = markEncoder.size), 
        markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.fill = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

SymbolSemanticMark.defaultSpec = {
    size: 10
}, SymbolSemanticMark.type = PlotMakType.symbol;
//# sourceMappingURL=symbol.js.map